class Terminal:
  def __init__(self):
    self.reset()

  def print(self, string:str=''):
    if self.mode == 'test':
      self.output_stream_as_list.append(string)
    else:
      print(string)
  
  def input(self, string=''):
    if self.mode == 'test':
      return self.input_stream_as_list.pop()
    else:
      return input(string)

  def reset(self):
    self.reset_stream_lists()
    self.mode = 'run'

  def reset_stdo(self):
    self.output_stream_as_list = []

  def reset_stdi(self):
    self.input_stream_as_list = []

  def reset_stream_lists(self):
    self.reset_stdi()
    self.reset_stdo()
